﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Character_AnimationManager : MonoBehaviour {

	[SerializeField] private Animator anim;
	[SerializeField] Renderer renderer;
	[SerializeField] private float stateChangeDuration = 3;
	public bool infected = false;

	void Start(){
		renderer.material = Instantiate (renderer.material);
		anim.SetBool ("Infected", infected);
		renderer.material.SetFloat ("_Blend", infected ? 1 : 0);
	}

	public void SetInfected (bool _infected){
		infected = _infected;
		anim.SetBool ("Infected", _infected);
		StartCoroutine (SetInfectedRoutine (_infected, stateChangeDuration));
	}

	private IEnumerator SetInfectedRoutine(bool _infected, float _duraction){
		
		renderer.material.SetFloat ("_Blend", _infected ? 0 : 1);
		float count = _duraction;
		float blend;
		while (_duraction > 0) {
			count -= Time.deltaTime;
			blend = (1f / _duraction) * count;
			renderer.material.SetFloat ("_Blend", _infected ? blend : 1 - blend);
			yield return null;
		}
		renderer.material.SetFloat ("_Blend", _infected ? 1 : 0);
	}

}
