﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class MasterCharacterManager : CharacterManager
{
	[Header("Character Components")]
	public CharacterVisionManager visionManager;

	[Header("Character Decisions")]
	[SerializeField]
	private NormieCharacterManager normie;
	[SerializeField]
	private InfectedCharacterManager infected;
	private CharacterDecisionManager activeDecider;

	public int activeCharacterIndex;

	#region AI Functions

	[ContextMenu ("Set Infected")]
	public void SetInfected()
	{
		infected.Initialize();
		activeDecider = infected;
		gameObject.layer = 10;
		MasterGameController.Instance.characterCreationManager.IncreaseInfectedCount();
	}

	public void InfectedSearching()
	{
		if (activeDecider == infected)
		{
			infected.BeginSearching();
		}
	}

	public void SetNormie(Vector3 destinationPosition)
	{
		SetNormie();
		normie.SetDestination(destinationPosition);
	}

	public void SetNormie()
	{
		normie.Initialize();
		activeDecider = normie;
		gameObject.layer = 9;
	}

	#endregion

	#region Mono Functions

	protected void Awake()
	{
		SetNormie();
	}

	protected void Update()
	{
		activeDecider.RunUpdate();
	}

	#endregion
}
