﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class BoardGeneration : MonoBehaviour
{
	public StreetLightContoller streetLightController;

	//Place prefabs of city blocks into here
	public GameObject[] cityTilePrefabs = new GameObject[9];

	//Instantiated when CreateBoard() is called
	private GameObject board;

	//Actual in game tiles
	public GameTile[] cityTiles = new GameTile[16];

	public bool isLoaded = false;

	#region Mono Functions

	// Use this for initialization
	void Start()
	{
		CreateBoard();
	}

	#endregion

	public void CreateBoard()
	{
		board = new GameObject ("Board");
		board.transform.position = new Vector3 (0, 0, 0);

		Vector3 position = new Vector3 (-1100, 0, -1100);


		for (int i = 0; i < 16; i++)
		{
			//pick a random prefab, place it in the next place	
			int tileToPlace = Random.Range(0, cityTilePrefabs.Length);

			//Place it in the next position
			cityTiles[i] = PlaceTile(cityTilePrefabs[tileToPlace], position, board);
			position.x += 1000;

			//Adjust position when 4 are placed in a row
			if (position.x == 2900)
			{
				position.x = -1100;
				position.z += 1000;
			}
		}
		isLoaded = true;

		// set components
		MasterGameController.Instance.streetLightController.GetLampSpawns();
		MasterGameController.Instance.characterCreationManager.SetSpawnPoints(cityTiles);
		MasterGameController.Instance.characterCreationManager.SetCharacters(cityTiles);
	}

	public GameTile PlaceTile(GameObject tile, Vector3 position, GameObject parent)
	{
		//Place tile at location
		Quaternion spawnRotation = Quaternion.Euler(0, 90 * Random.Range(0, 3), 0);

		GameObject go = Instantiate(tile, position, spawnRotation, parent.transform);
		return go.GetComponent<GameTile>();
	}

	public void PlaceBorder()
	{
		//Need border pieces. Should always instantiate into the same place
	}

	public void DestroyBoard()
	{
		isLoaded = false;
		Destroy(board);
	}

}
