﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class EnvironmentController : MonoBehaviour
{

	public static EnvironmentController instance;
	[SerializeField] private RectTransform timerFill;
	[Range(0, 1)] private float progress = 0;
	//Settings
	[SerializeField]private GameObject sunLight;
	[SerializeField]private float startAngle;
	[SerializeField]private float endAngle;


	void Start()
	{
		sunLight.transform.localRotation = Quaternion.Euler(new Vector3 (
			startAngle * progress + startAngle,
			0,
			0));

		RenderSettings.ambientLight = new Color (
			0,
			0,
			0);
		timerFill.localRotation = Quaternion.Euler(new Vector3 (
			0,
			0,
			180
		));

		StartCoroutine(UpdateRoutine());
	}

	public void setTime(float _NewTime)
	{
		if (_NewTime >= 0 && _NewTime <= 1)
		{
			progress = _NewTime;
		}
	}



	private IEnumerator UpdateRoutine()
	{
		while (gameObject)
		{
			if (progress < 1f && MasterGameController.Instance.currentGamePhase == MasterGameController.GamePhase.active)
			{
				progress = MasterGameController.Instance.timeController.GetCurrentTime() / MasterGameController.Instance.timeController.GameDuration;

				sunLight.transform.localRotation = Quaternion.Euler(new Vector3 (
					(endAngle - startAngle) * progress + startAngle,
					0,
					0));

				RenderSettings.ambientLight = new Color (
					progress,
					progress,
					0);
				timerFill.localRotation = Quaternion.Euler(new Vector3 (
					0,
					0,
					progress * -180 + 180
				));
			}

			yield return null;
		}
	}
}
