﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class SoundController : MonoBehaviour {
	//PreFabs
	public GameObject SFXPrefab;
	//AudioSources
	public AudioSource BGAudioSouce;
	/*
	 * 0 = infectHuman
	 * 1 = zombieMoan
	 * 2 = StartUpSound
	 * 3 = buttonClick
	 * 4 = lightClick
	 */
	public AudioSource[] soundFX = new AudioSource[5];

	//Audio Clips
	public AudioClip bgMusic;

	#region Mono Functions

	// Use this for initialization
	void Start () 
	{
		StartBGMusic ();
		CreateSFXObject ();
	}
	
	// Update is called once per frame
	void Update () 
	{
		
	}

	#endregion

	#region AudioCalls

	public void StartBGMusic()
	{
		//Create an object for the BG music to loop from, and then play and loop it
		GameObject BGAudioObject = new GameObject("BGMusic");
		BGAudioObject.AddComponent<AudioSource>();
		BGAudioSouce = BGAudioObject.GetComponent<AudioSource> ();

		BGAudioSouce.clip = bgMusic;
		BGAudioSouce.loop = true;
		BGAudioSouce.Play ();

	}

	void CreateSFXObject()
	{
		//Instantiate the premade SFX audio object
		GameObject SFXAudioObject = Object.Instantiate(SFXPrefab);

		//Make an array of the audio sources so calling is easier. Could call by ID as ID will be == element#
		soundFX = SFXAudioObject.GetComponentsInChildren<AudioSource>();
	}

	/* 0 = infectHuman
	 * 1 = zombieMoan
	 * 2 = StartUpSound
	 * 3 = buttonClick
	 * 4 = lightClick
	 */
	public void PlaySFX(int clipID)
	{
		if (soundFX [clipID] != null) {
			soundFX [clipID].Play ();
		} else {
			Debug.Log ("Error playing clip");
		}
	}

	#endregion

}
