﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class StreetLamp : MonoBehaviour {
	// states
	private bool isOn = false;
	public Light light;
	public AudioSource lightClick;

	#region Getters Functions

	public bool IsOn 
	{
		get {return isOn;} 
		set {isOn = value;}
	}

	#endregion

	//SwitchLight Function. Call this from the touch command for it.
	public void SwitchLight()
	{
		if (lightClick.isPlaying == false) 
		{
			lightClick.Play ();
		}
		if (isOn == true) 
		{
			//Debug.Log ("Turn Off");
			isOn = false;
			light.enabled = false;
		} else 
		{
			//Debug.Log ("Turn On");
			isOn = true;
			light.enabled = true;
		}
	}


	#region Mono Functions
	void Start () {

	}

	void OnMouseDown(){
		SwitchLight ();
	}

	void OnCollisionEnter(Collision collisionInfo){
		print("Now in contact with " + collisionInfo.transform.name);

		DetectableObject objectCollided = collisionInfo.transform.gameObject.GetComponent<DetectableObject> ();
		if (objectCollided != null) {
			objectCollided.IsInLight = true;
		}
	}

	void OnCollisionExit(Collision collisionInfo) {
		print("No longer in contact with " + collisionInfo.transform.name);

		DetectableObject objectCollided = collisionInfo.transform.gameObject.GetComponent<DetectableObject> ();
		if (objectCollided != null) {
			objectCollided.IsInLight = false;
		}
	}

	#endregion

}