﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class StreetLightContoller : MonoBehaviour
{
	public BoardGeneration boardController;

	//The prefab to spawn
	public GameObject streetLamp;

	//Popuplate with all possible spawnpoints. As is I expect 4 spawnpoints per block
	List<GameObject> lightSpawnPoints = new List<GameObject> ();

	//Number of lightposts to spawn in
	public int lightsToSpawn = 24;

	//Change this to an array of StreetLamps[] once I make the class
	public List<StreetLamp> streetLamps = new List<StreetLamp>();

	public void GetLampSpawns()
	{
		streetLamps.Clear();
		for (int i = 0; i < boardController.cityTiles.Length; i++)
		{
			for (int j = 0; j < boardController.cityTiles[i].streetlamps.Length; j++)
			{
				lightSpawnPoints.Add(boardController.cityTiles[i].streetlamps[j].gameObject);
			}
		}
		SpawnLamps();
	}

	void SpawnLamps()
	{
		//Spawn 0
		//Add (Spawns/NumberToSpawn) rounded up but not over max
		int j = 0;
		for (int i = 0; i < lightsToSpawn; i++)
		{
			streetLamps.Add(Object.Instantiate(streetLamp, lightSpawnPoints[j].transform.position, Quaternion.identity, lightSpawnPoints[j].transform).GetComponent<StreetLamp>());//Instanitate light

			j += Mathf.RoundToInt(lightSpawnPoints.Count / lightsToSpawn);//Move forward X spaces to space out lights and prevent overlap
		}
	}
}
