﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class TapController : MonoBehaviour
{
	[SerializeField]
	private LayerMask LightSource; //tapMask
	// Update is called once per frame
	void Update()
	{
		RaycastHit hit;
		// If the number of fingers that are touching is > 0 and the first finger has started to touch the screen
		if (Input.touchCount > 0 && Input.GetTouch (0).phase == TouchPhase.Began) {	
			// Construct a ray from the current touch coordinates
			if (Physics.Raycast (Camera.main.ScreenPointToRay (Input.GetTouch (0).position), out hit, Mathf.Infinity, LightSource)) {
				Debug.Log ("Touch");
				Debug.Log ("got something: " + hit.collider.gameObject.name);
				StreetLamp lamp = hit.collider.GetComponentInParent<StreetLamp> ();
				if (lamp != null) {
					lamp.SwitchLight ();
				}
			}
		}
		else if (Input.GetMouseButtonDown (0))
		{
			if (Physics.Raycast (Camera.main.ScreenPointToRay (Input.mousePosition), out hit, Mathf.Infinity, LightSource)) 
			{
			Debug.Log ("click");
			Debug.Log ("got something: " + hit.collider.gameObject.name);
			StreetLamp lamp = hit.collider.GetComponentInParent<StreetLamp> ();
			if (lamp != null) {
				lamp.SwitchLight ();
			}
				}
	}

}
}